/***********************************************************************/
/*                                                                     */
/*  FILE        :SWTEST0c.c                                             */
/*  DATE        :Tue, Jun 08, 2010                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH72620                                               */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.16).    */
/*                                                                     */
/***********************************************************************/
/*
 *	Switch Test Program
 *		Input
 *			PE1 : Clear SW		: 0 = Pushed
 *			PE0 : Count SW		: 0 = Pushed
 *		Output
 *			PD0..7 : 7seg LED	: 0 = On, 1 = Off
*/

#include <machine.h>
#include "iodefine.h"
//#include "typedefine.h"
#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

#define	USE_CACHE						// Remove the comment when you use cache
#if defined(USE_CACHE)
#include "cache.h"
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

/************************************************************************/

#define	SW_CLEAR		0x0002
#define	SW_COUNT		0x0001
#define	SW_MASK			(SW_CLEAR | SW_CONUT)

/*	NbNg̐ݒ	*/
void init_ClockFreq(void)
{
	CPG.FRQCR.WORD = 0x1104;				// NbN I:B:P = 144:48:24 MHz
}

/*	 |[g̐ݒ	*/
void init_PORT(void)
{
	PORT.PCDR0.BYTE.H |= 0x01;				// PC8LED

	PORT.PCIOR0.WORD |= 0x0100;				// PC8o͂ɐݒ
	PORT.PCCR2.WORD &= 0xFFF0;				// PC8̋@\ݒ

	PORT.PDDR0.BYTE.L |= 0x00FF;			// PD0..7LED

	PORT.PDIOR0.WORD |= 0x00FF; 			// PD0..7o͂ɐݒ
	PORT.PDCR0.WORD = 0x0000;				// PD0..3̋@\ݒ
	PORT.PDCR1.WORD = 0x0000;				// PD4..7̋@\ݒ

	PORT.PEIOR0.WORD &= 0xFFFC;				// PE0..1͂ɐݒ
	PORT.PECR0.WORD &= 0xFFF0;				// PE0..1̋@\ݒ
}

/*	LEDON		*/
void led_on()
{
	PORT.PCDR0.BYTE.H &= 0xFEu;				// PC8LED_
}

/*	LEDOFF	*/
void led_off()
{
	PORT.PCDR0.BYTE.H |= 0x01u;				// PC8LED
}

/************************************************************************/

volatile int timer_count;					// ^C}pJE^

/*	 CMT0̐ݒ	*/
void init_CMT(void)
{
	timer_count = 0;						// ^C}pJE^

	CPG.STBCR7.BIT.MSTP72 = 0;				// CMTNbNJn

	CMT.CMSTR.BIT.STR0 = 0;					// CMCNT0JEg~

    CMT.CMCNT0.WORD = 0;					// CMCNT0ݒ 0NA

	CMT.CMCSR0.WORD = 0x0041;				// 荞݋, 32(24MHz/32=750kHz)

	CMT.CMCOR0.WORD = 7499;					// 10msɊ荞

	INTC.IPR10.BIT._CMT0 = 14;				// 荞ݗDx14
	set_imask(0);

	CMT.CMSTR.BIT.STR0 = 0x1;				// CMCNT0JEgJn
}

/*	^C}荞ݏvO	*/
void int_cmt_cmi0(void)
{
	CMT.CMCSR0.BIT.CMF = 0;					// CMF0̃NA
	timer_count++;							// ^C}pJEgAbv
}

/************************************************************************/
/*	Delay																*/
/************************************************************************/
/*	ӁF̒l͓KŁCmł͂Ȃ	*/
#if defined(USE_CACHE)
#define LOOP_DLY_100US  1600
#else
#define LOOP_DLY_100US  350
#endif

void Delay(unsigned long dly)
{
	volatile int i;

	while (dly--)
	{
	    for (i = LOOP_DLY_100US; i; i--)
			;
	}
}

/************************************************************************/
/*	Convert binary to 7 segments LES's data								*/
/************************************************************************/
int ConvBinTo7Seg(int bin, int dp)
{
	static int led_data[16] = {
		0x0040, 0x0079, 0x0024, 0x0030, 0x0019, 0x0012, 0x0002, 0x0058,
		0x0000, 0x0010, 0x0008, 0x0003, 0x0046, 0x0021, 0x0006, 0x000e
	};
	int	cd = 0;

	cd = led_data[bin & 0x0f];
	if (!dp)
		cd |= 0x0080;
	return cd;
}

/************************************************************************/

void main(void)
{
	_UBYTE	sw_cur;							// XCb`݂̌̏
	int		count;							// JE^

	init_ClockFreq();						// NbNg̐ݒ
#if defined(USE_CACHE)
	Cache_Init( );							// LbVL
#endif

	init_PORT();							// |[g̐ݒ
	count = 0;								// JE^

//	init_CMT();								// ^C}[̐ݒ

	while (1)								// [v
	{
		sw_cur = PORT.PEDR0.BYTE.L;			// XCb`̏Ԃ

		if (!(sw_cur & SW_COUNT))			// Count SWĂ0̂Ƃ
		{
			if (++count >= 10)				//   JEgAbvC10ɂȂ
				count = 0;					//   0ɖ߂
		}

		if (!(sw_cur & SW_CLEAR))			// Clear SWĂ0̂Ƃ
			count = 0;						//   JE^

		PORT.PDDR0.BYTE.L = ConvBinTo7Seg(count, 0);
											// JE^̒lLEDɏo
	}
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
